<?php
//Script modificado por Carlos www.meteoviso.es 


ini_set('display_startup_errors', 1);
ini_set('display_errors', 0);
error_reporting(-1);

header('Content-Type: text/html; charset=iso-8859-1');






########### Configuración ###########
$codigozona = '614102';   // Campiña Sevillana Código de la zona de avisos. Se puede ver en el pdf de AEMET: //http://www.aemet.es/documentos/es/eltiempo/prediccion/avisos/plan_meteoalerta/detalle_municipios_zonas_meteorologicas.pdf
//$codigozona = '733001';   // Código de la zona de avisos. Se puede ver en el pdf de AEMET: //http://www.aemet.es/documentos/es/eltiempo/prediccion/avisos/plan_meteoalerta/detalle_municipios_zonas_meteorologicas.pdf

$nombrezona = utf8_decode('Campiña Sevillana');  // Nombre de la zona del aviso.
$provincia = 'Sevilla';

#####################################

if (!$codigozona) exit('Hay que poner el código de la zona');

date_default_timezone_set('Europe/Madrid');

function icono_aviso($icono, $nivel){
	$res = "";
	global $res1;
	$res1 = "";
	if (strstr($icono, 'PR')) {$res = 'PR'; $res1 = 'Lluvias';}
	elseif (strstr($icono, 'TO')) {$res = 'TO'; $res1 = 'Tormentas';}
	elseif (strstr($icono, 'VI')) {$res = 'VI'; $res1 = 'Viento';}
	elseif (strstr($icono, 'AT')) {$res = 'AT'; $res1 = utf8_decode('Temperaturas máximas');}
	elseif (strstr($icono, 'BT')) {$res = 'BT'; $res1 = utf8_decode('Temperaturas mínimas');}
	elseif (strstr($icono, 'NE')) {$res = 'NE'; $res1 = 'Nevadas';}
	elseif (strstr($icono, 'NI')) {$res = 'NI'; $res1 = 'Nieblas';}
	elseif (strstr($icono, 'DH')) {$res = 'DH'; $res1 = 'Deshielos';}
	elseif (strstr($icono, 'RI')) {$res = 'RI'; $res1 = 'Rissaga';}
	elseif (strstr($icono, 'VS')) {$res = 'VS'; $res1 = 'Visibilidad';}
	elseif (strstr($icono, 'AL')) {$res = 'AL'; $res1 = 'Aludes';}
	elseif (strstr($icono, 'GA')) {$res = 'GA'; $res1 = 'Galernas';}
	elseif (strstr($icono, 'CO')) {$res = 'CO'; $res1 = 'Costeros';}
	return 'http://www.aemet.es/imagenes/gif/iconos_avisos/'.$res.$nivel.'.gif';
}

$avisoamar = ""; $avisonara = ""; $avisorojo = "";

$semana = ['Domingo', 'Lunes', 'Martes', 'Mi&eacute;rcoles', 'Jueves', 'Viernes', 'S&aacute;bado'];

$meses = ['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto', 'septiembre', 'octubre', 'noviembre', 'diciembre'];

$riesgo = ['', '<div span class="avisos1"><a href="http://www.aemet.es/es/eltiempo/prediccion/avisos?l='.'" style=" text-decoration: None;color:black;margin-left:0px;font-size:11px;">Avisos AEMET&nbsp;&nbsp;&nbsp;&nbsp;'.$nombrezona.'&nbsp;&nbsp;&nbsp;&nbsp;Alerta Roja&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div span>', '<div span class="avisos2"><a href="http://www.aemet.es/es/eltiempo/prediccion/avisos?l='.'" style=" text-decoration: None;color:black;margin-left:0px;font-size:11px;">Avisos AEMET&nbsp;&nbsp;&nbsp;&nbsp;'.$nombrezona.'&nbsp;&nbsp;&nbsp;&nbsp;Alerta Naranja&nbsp;&nbsp;</div span>', '<div span class="avisos3"><a href="http://www.aemet.es/es/eltiempo/prediccion/avisos?l='.'" style=" text-decoration: None;color:black;margin-left:0px;font-size:11px;">&nbsp;Avisos AEMET&nbsp;&nbsp;&nbsp;&nbsp;'.$nombrezona.'&nbsp;&nbsp;&nbsp;&nbsp;Alerta Amarilla&nbsp;&nbsp;</div span>'];

$alerta = ['', '<span class="avisos1" style="padding:0px;">&nbsp;&nbsp;&nbsp;Roja&nbsp;&nbsp;&nbsp;</span>', '<span class="avisos2" style="padding:0px;">Naranja</span>', '<span class="avisos3" style="padding:0px;">Amarilla</span>'];

$lista = [];

$lista[] = date('Y-m-d');

$lista[] = date('Y-m-d', strtotime("+1 day"));

$lista[] = date('Y-m-d', strtotime("+2 day"));

$jsons = [];

for ($i = 0; $i < 3; $i++){
			
	$jsons[] = json_decode(file_get_contents('http://www.aemet.es/es/api-eltiempo/resumen-lista-avisos/PB/'.$lista[$i].'T12:00:00+02:00/D+0/'.$codigozona));
	
}

$res = "";
$exit = 0;

$horaact = time();
$activo = "";
$sinavisos = "";
$activonot = "";
$finaviso = $flagaviso = 0;


foreach ($jsons as $dia=>$items) {
		

		if (empty($items->{'orden_avisos'})) {$exit += 1; continue;}
		else {
			$epoch = strtotime($lista[$dia]);
			$res .= '<tr><th class="dia_tabla" colspan="8">'.$semana[date('w',$epoch)].' '.date('j',$epoch).' de '.$meses[date('n',$epoch)-1].'</th></tr>';
			foreach ($items as $item2){			
				
				$res .='<tr><th>&nbsp;&nbsp;&nbsp;Alerta&nbsp;&nbsp;&nbsp;</th><th>&nbsp;Fen&oacute;meno&nbsp;</th><th>Descripci&oacute;n</th><th>&nbsp;&nbsp;&nbsp;&nbsp;Valor&nbsp;&nbsp;&nbsp;&nbsp;</th><th>&nbsp;&nbsp;Inicio&nbsp;&nbsp;</th><th>&nbsp;&nbsp;&nbsp;&nbsp;Fin&nbsp;&nbsp;&nbsp;&nbsp;</th></tr>';
				
				foreach ($item2 as $item3){
				++$flagaviso;
				$ini = strtotime($item3[1]->{'Onset'});
				$fin = strtotime($item3[1]->{'Expire'});
				if ($horaact > $fin) {$finaviso += 1; continue;}
				elseif ($horaact > $ini and $horaact < $fin and date('d',$epoch) == date('d')) {$activo = ' class="activo"'; $activonot = '<br><span class="blinking" style="font-weight: bold; display: inline-block; margin-top:0px;">ACTIVO</span>';}
				$nivel = $item3[1]->{'Nivel'};
				if ($nivel == 1) $avisorojo = 1;
				elseif ($nivel == 2) $avisonara = 1;
				elseif ($nivel == 3) $avisoamar = 1;
				
				
				$res .= '<tr'.$activo.'><td>'.$alerta[$nivel].$activonot.'</td><td class="estrecho"><img src="'.icono_aviso($item3[1]->{'FemParam'}, $nivel).'" /><br/><td>&nbsp;'.$res1.'</td><td class="estrecho">'.cambio(($item3[1]->{'Valor'})).'</td><td class="start">'.date('H:i', $ini).'</td><td class="end">&nbsp;'.date('H:i', $fin).'&nbsp;</td></tr>';	
				
				$activo = $activonot = "";
				}
			if ($finaviso == $flagaviso) {$res = ""; $sinavisos = 1;}
			}
		}		
}

$filaavisos = "";

if ($avisorojo) $filaavisos .= $riesgo[1];
if ($avisonara) $filaavisos .= $riesgo[2];
if ($avisoamar) $filaavisos .= $riesgo[3];

$resulavisos = "";

if ($exit == 3 or $exit == 2 && $sinavisos) $resulavisos = '<div id="sin_riesgo"><a href="http://www.aemet.es/es/eltiempo/prediccion/avisos?l='.$codigozona.'" style=" text-decoration: None;color:black;margin-left:0px;font-size:11px;">Avisos AEMET '.$nombrezona.'<span style="color: black; background-color: #32CD32; padding: 0px; font-size: 11px; margin-left: 15px;">Sin Avisos&nbsp;&nbsp;&nbsp;&nbsp;+ INFO</span></a></div>';
else $resulavisos = '<div class="tabla_avisos_open" style="border: 0px solid red;"><div id="riesgo">'.$filaavisos.'<a style="color:black; cursor: pointer; margin-left:0px; font-size: 11px;"></a></div><table id="tabla_avisos">'.$res.'</table></div>';

echo $resulavisos;
/*
// Si se desmarca no sale banda cuando no hay alertas
if ($exit == 3 or $exit == 2 && $sinavisos);
else $resulavisos = '<div class="tabla_avisos_open" style="border: 5px solid red;"><div id="riesgo">Avisos AEMET '.$nombrezona.$filaavisos.'<a class="tabla_avisos_open"class="tabla_avisos_open" style="color:white; cursor: pointer; margin-left:15px; font-size: 10px;">+ INFO</a></div><table id="tabla_avisos">'.$res.'</table></div>';

echo $resulavisos;
*/
?>
<style>
#original_tabla_avisos{
	width: 100%;
	border-collapse: collapse;
	border: 1px solid black;
	font-size: 11px;
	font-family: sans-serif;
}

#tabla_avisos {
  width: 100%;
  border-collapse: collapse;
  border: 1px solid black;
  font-size: 2vw; /* Utiliza la unidad vw para el tamaño de fuente */
  font-family: sans-serif;
  table-layout: auto;
  overflow-x: auto;
}

@media (max-width: 768px) {
  #tabla_avisos {
    font-size: 3.5vw; /* Ajusta el tamaño de fuente en dispositivos móviles con pantallas pequeñas */
  }
}





.estrecho{
	width:5%;
}

#tabla_avisos th{
	padding: 0px;
	border: 1px solid black;
	background-color: lightblue;
}

#tabla_avisos td{
	border: 1px solid black;
	text-align: center;
	background-color: #E0E0E0;
	padding: 0px;
}

.xdia_tabla{
	background-color: #3173B1 !important;
	color: white;
	font-size: 11px;
	text-align: center;
}

.avisos3 {
background-color: yellow;
color:black;
border: 0px solid yellow;
padding:3px;
}
.avisos2 {
background-color: orange;
color:black;
border: 0px solid orange;
padding:3px;
}
.avisos1 {
background-color: red;
color:white;
border: 0px solid red;
padding:3px;
}

#riesgo {
background-color:  ;
font-size: 11px;
font-weight: bold;
text-align: center;
color: white;
padding: 0px;
}

#riesgo span{
margin-left: 0px;
font-size: 14px;
}

#sin_riesgo {
background-color: #32CD32;
font-size: 10px;
font-weight: bold;
text-align: center;
color: black;
padding: 3px;
border: 0px solid #32CD32;
}

.activo td{
background-color: #ff7272 !important;
}

.blinking{
    animation: blinkingText 1.2s infinite;
}

@keyframes blinkingText{
    0%{     color: #000;    }
    49%{    color: #000; }
    60%{    color: transparent; }
    99%{    color:transparent;  }
    100%{   color: #000;    }
}

</style>
</div>
<?php
function cambio($cadena) 
{
   $search = explode(",","mm");
   $replace = explode(",","l/m²");
   $cadena= utf8_decode(str_replace($search, $replace, $cadena));

   return $cadena;
}


?>

 <div id="colorDisplay">
        Color de fondo: <span id="bgColor"></span><br>
        Color del texto: <span id="textColor"></span>
    </div>


    <script>
	
        // Función para convertir RGB a HEX
        function rgbToHex(r, g, b) {
            return '#' +
                ('0' + parseInt(r, 10).toString(16)).slice(-2) +
                ('0' + parseInt(g, 10).toString(16)).slice(-2) +
                ('0' + parseInt(b, 10).toString(16)).slice(-2);
        }

        // Función para convertir rgba a rgb y luego a hex
        function rgbaToHex(rgba) {
            var rgb = rgba.match(/\d+/g);
            if (rgb) {
                return rgbToHex(rgb[0], rgb[1], rgb[2]);
            }
            return '#000000'; // Fallback color
        }

        // Función para enviar colores al servidor
        function sendColorsToServer(bgColor, textColor) {
            var xhr = new XMLHttpRequest();
            xhr.open("POST", "", true); // Enviar a la misma URL
            xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
            xhr.send("bgColor=" + encodeURIComponent(bgColor) + "&textColor=" + encodeURIComponent(textColor));
        }

        // Función para inyectar estilos dinámicamente
        function applyDynamicStyles(bgColor, textColor) {
            var style = document.createElement('style');
            style.textContent = `
                .dia_tabla {
                    background-color: ${bgColor} !important;
                    color: ${textColor} !important;
					font-size: 11px;
	                text-align: center;
                }
            `;
            document.head.appendChild(style);
        }

        function displayColors() {
            var element = document.querySelector('.ajaxDashboard .datahead');
            if (element) {
                var style = window.getComputedStyle(element);

                // Obtener color de fondo
                var backgroundColor = style.getPropertyValue('background-color');
                var bgColorHex = rgbaToHex(backgroundColor);
                document.getElementById('bgColor').innerText = bgColorHex;

                // Obtener color del texto
                var textColor = style.getPropertyValue('color');
                var textColorHex = rgbaToHex(textColor);
                document.getElementById('textColor').innerText = textColorHex;

                // Enviar colores al servidor
                sendColorsToServer(bgColorHex, textColorHex);

                // Aplicar estilos dinámicamente
                applyDynamicStyles(bgColorHex, textColorHex);
            }
        }

        // Asegurarse de que el DOM esté completamente cargado
        document.addEventListener('DOMContentLoaded', displayColors);
    </script>
<style>
#colorDisplay {
    display: none;
}
</style>


